unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  a,b,c:Tpoint;
implementation

{$R *.dfm}
Function Dlina(a,b:Tpoint):Extended; //     
var x1,y1,x2,y2:real;
begin
x1:=a.x;
y1:=a.y;
x2:=b.x;
y2:=b.y;
   result:=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
end;
Function GetS(a,b,c:Tpoint):real; //  
var p,r1,r2,r3:real;
begin
 r1:=Dlina(a,b);
 r2:=Dlina(b,c);
 r3:=Dlina(c,a);
 p:=(r1+r2+r3)/2;
 if p*(p-r1)*(p-r2)*(p-r3)>0 then
 result:=sqrt(p*(p-r1)*(p-r2)*(p-r3))
 else result:=0;
end;
Function GetPointInTR(a,b,c,Pn:Tpoint):boolean;
begin
   result:=abs(GetS(a,b,c)-GetS(a,b,pn)-GetS(a,pn,c)-GetS(pn,b,c))<0.0001;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   a:=point(50,250);
   b:=point(200,250);
   c:=point(135,100);
   Label2.Caption:=' ABC = '+FormatFloat('0.00',GetS(a,b,c))+#13#10;

end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var d:Tpoint;
begin
  d:=point(x,y);

  form1.Canvas.MoveTo(a.X,a.y);
  form1.Canvas.lineto(b.X,b.y);
  form1.Canvas.lineto(c.X,c.y);
  form1.Canvas.lineto(a.X,a.y);

  Label2.Caption:=' ABC = '+FormatFloat('0.00',GetS(a,b,c))+#13#10+' ABD = '+FormatFloat('0.00',GetS(a,b,d))+#13#10+' ADC = '+FormatFloat('0.00',GetS(a,d,c))+#13#10+' DBC = '+FormatFloat('0.00',GetS(d,b,c));
  Label2.Caption:=Label2.Caption+#13+#10+' S(ABC)-S(ABD)-S(ADC)-S(DBC)='+FormatFloat('0.00',GetS(a,b,c)-GetS(a,b,d)-GetS(a,d,c)-GetS(d,b,c));

  if GetPointInTR(a,b,c,d) then label1.Caption:=' ' else label1.Caption:=' ';
  end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;

end.
